P.m = 20;
P.n = P.m;
P.price_min = 0.25;
P.price_step_size = 0.025;
P.n_strategies = 21;
P.model_variant = 1;
P.learning_neighborhood = 1;
P.n_rounds = 1e6;
P.n_simulation_runs = 5e2;
P.random_state = 0;
noise_levels = [0 0.05 0.1 0.25];
experimentation_probs = [0 1e-5 1e-4 1e-3];

tic;
mean_final_prices = zeros(length(noise_levels), length(experimentation_probs));
st_dev_final_prices = zeros(length(noise_levels), length(experimentation_probs));
mean_prices = zeros(length(noise_levels), length(experimentation_probs), P.n_rounds);
for i = 1:length(noise_levels)
    P.noise_level = noise_levels(i);
    for j = 1:length(experimentation_probs)
        P.experimentation_prob = experimentation_probs(j);
        [mean_final_prices(i, j), st_dev_final_prices(i, j), mean_prices(i, j, :)] = run_model2(P);
    end
end
toc;